const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const modelos_bim_asbuilt = sequelize.define(
    'modelos_bim_asbuilt',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      nome_modelo: {
        type: DataTypes.TEXT,
      },

      descricao: {
        type: DataTypes.TEXT,
      },

      arquivo_modelo: {
        type: DataTypes.TEXT,
      },

      formato: {
        type: DataTypes.TEXT,
      },

      plataforma_origem: {
        type: DataTypes.TEXT,
      },

      data_modelagem: {
        type: DataTypes.DATEONLY,

        get: function () {
          return this.getDataValue('data_modelagem')
            ? moment
                .utc(this.getDataValue('data_modelagem'))
                .format('YYYY-MM-DD')
            : null;
        },
      },

      responsavel_modelagem: {
        type: DataTypes.TEXT,
      },

      nivel_detalhamento: {
        type: DataTypes.TEXT,
      },

      coordenacao_com_outros_modelos: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      comentarios: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  modelos_bim_asbuilt.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.modelos_bim_asbuilt.belongsTo(db.obras, {
      as: 'obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.modelos_bim_asbuilt.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.modelos_bim_asbuilt.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.modelos_bim_asbuilt.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return modelos_bim_asbuilt;
};
